// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Bindable node abstract class. The base class for all bindable nodes.
// Background, Fog, NavigationInfo and Viewpoint

package vlc.vrml.external.geometry;

import vrml.external.*;
import vrml.external.field.*;

public abstract class BindableNode extends ChildrenNode
{
	protected EventInSFBool	_set_bind;

	protected EventOutSFBool _get_isBound;

	protected boolean _bound;

	public void set_bind(boolean val)
	{
		_bound = val;
		if(have_browser)
			_set_bind.setValue(val);
	}

	public boolean get_isBound()
	{
		return(_get_isBound.getValue());
	}
}