// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Coordinate class.

package vlc.vrml.external.geometry;

import java.io.PrintStream;
import vrml.external.*;
import vrml.external.field.*;

public class Coordinate extends VrmlObject
{
	private EventInMFVec3f _set_coordinate;

	private float[][] _coordinate;

	public Coordinate()
	{
		Browser b = Browser.getBrowser();

		if(b == null)
			return;

		node = b.createVrmlFromString("Coordinate {}")[0];

		createFields();
	}

	public Coordinate(Browser b)
	{
		if(b == null)
			return;

		node = b.createVrmlFromString("Coordinate {}")[0];

		createFields();
	}

	private void createFields()
	{
		_set_coordinate = (EventInMFVec3f)node.getEventIn("point");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.Coordinate;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int     i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "coord ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println("Coordinate {");

		if(_coordinate.length > 0)
		{
			fp.print(buffer.toString() + "  point ");

			if(_coordinate.length == 1)
				fp.println(_coordinate[0]);
			else
			{
				fp.println("[");

				for(i = 0; i < _coordinate.length; i++)
					fp.println(buffer.toString() + "  " + _coordinate[i]);

				fp.println(buffer.toString() + "  ]");
			}
		}
		fp.println(buffer.toString() + "}");
	}

	public void set_coordinate(float[][] point)
	{
		_coordinate = point;
		if(have_browser)
			_set_coordinate.setValue(point);
	}
	
	public float[][] get_coordinate()
	{
		return(_coordinate);
	}
}
