// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Normal class.

package vlc.vrml.external.geometry;

import java.io.PrintStream;
import vrml.external.*;
import vrml.external.field.*;

public class Normal extends VrmlObject
{
	private EventInMFVec3f _set_vector;

	private float[][] _vector;

	public Normal()
	{
		Browser b = Browser.getBrowser();

		if(b == null)
			return;

		node = b.createVrmlFromString("Normal {}")[0];

		createFields();
	}

	public Normal(Browser b)
	{
		if(b == null)
			return;

		node = b.createVrmlFromString("Normal {}")[0];

		createFields();
	}

	private void createFields()
	{
		_set_vector = (EventInMFVec3f)node.getEventIn("vector");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.Normal;
	}
	public void writeToFile(PrintStream fp, int indent)
	{
		int     i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "normal ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println("Normal {");

		if(_vector.length > 0)
		{
			fp.print(buffer.toString() + "  vector ");

			if(_vector.length == 1)
				fp.println(_vector[0]);
			else
			{
				fp.println("[");

				for(i = 0; i < _vector.length; i++)
					fp.println(buffer.toString() + "  " + _vector[i]);

				fp.println(buffer.toString() + "  ]");
			}
		}
		fp.println(buffer.toString() + "}");
	}

	public void set_vector(float[][] vector)
	{
		_vector = vector;
		if(have_browser)
			_set_vector.setValue(vector);
	}
	
	public float[][] get_vector()
	{
		return(_vector);
	}
}
