// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// Box class

package vlc.vrml.internal.geometry;

import java.io.*;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class Box extends Geometry
{
	private float[] _size = null;

	public Box(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("Box {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}
		
		type = vlc.vrml.VrmlTypes.Box;
	}

	public Box(Browser b, float x, float y, float z)
	{
		_size = new float[3];

		_size[0] = x;
		_size[1] = y;
		_size[2] = z;

		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("Box { size " +
												 x + " " +
												 y + " " +
												 z + "}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		have_browser = true;
		type = vlc.vrml.VrmlTypes.Box;
	}

	public void cleanup()
	{
		_size = null;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int	i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "geometry ");
		if(name != null)
			fp.print("DEF " + name + " ");

		fp.print("Box {");

		if(_size != null)
			fp.print(" size " +
					 _size[0] + " " +
					 _size[1] + " " +
					 _size[2]);

		fp.println("}");
	}

	public float[] get_size()
	{
		return(_size);
	}
}
