// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// geometry sensor abstract class for the plane, sphere and cylinder sensors

package vlc.vrml.internal.geometry;

import vrml.field.*;

public abstract class GeometrySensor extends Sensor
{
	protected SFRotation	_set_offset;
	protected SFBool		_set_autoOffset;

	protected ConstSFRotation	_get_rotation_changed;
	protected ConstSFVec3f		_get_trackPoint_changed;

	protected float[]	_offset = { 0, 1, 0, 0};
	protected boolean	_autoOffset = true;

	// just to stop people creating instances of the Sensor
	protected GeometrySensor()
	{
	}

	public void set_offset(float[] offset)
	{
		_offset = offset;
		if(have_browser)
			_set_offset.setValue(offset);
	}

	public float[] get_offset()
	{
		return(_offset);
	}

	public void set_autoOffset(boolean auto)
	{
		_autoOffset = auto;
		if(have_browser)
			_set_autoOffset.setValue(auto);
	}

	public boolean get_autoOffset()
	{
		return(_autoOffset);
	}

	public float[] get_rotation_changed()
	{
		float[] val = null;

		_get_rotation_changed.getValue(val);

		return(val);
	}

	public float[] get_trackPoint_changed()
	{
		float[] val = null;

		_get_trackPoint_changed.getValue(val);

		return(val);
	}
}