// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// ImageTexture class

package vlc.vrml.internal.geometry;

import java.io.PrintStream;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class ImageTexture extends Texture
{
	MFString _set_url;

	String[]	url;

	public ImageTexture(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("ImageTexture {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		createFields();
	}

	public ImageTexture(Browser b, boolean rptS, boolean rptT)
	{
		String  tmp = "ImageTexture { ";

		repeatS = rptS;
		repeatT = rptT;

		if(!repeatS)
			tmp += "repeatS FALSE ";
		if(!repeatT)
			tmp += "repeatT FALSE ";

		tmp += "}";

		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString(tmp)[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}


		createFields();
	}

	private void createFields()
	{
		_set_url = (MFString)node.getEventIn("url");
		have_browser = true;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int     i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "texture ");
		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println("ImageTexture {");

		if(!repeatS)
			fp.println(buffer.toString() + "  repeatS FALSE");
		if(!repeatT)
			fp.println(buffer.toString() + "  repeatT FALSE");

		if(url.length > 0)
		{
			fp.println(buffer.toString() + " url [");

			for(i = 0; i < url.length; i++)
			{
				fp.println(buffer.toString() + "    \"" +
					   url[i] + "\"");
			}
			fp.println(buffer.toString() + "  ]");
		}
		fp.println(buffer.toString() + "}");
	}

	public void set_url(String[] new_url)
	{
		url = new_url;
		if(have_browser)
			_set_url.setValue(url);
	}

	public String[] get_url()
	{
		return(url);
	}
}
