// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// PositionInterpolator class

package vlc.vrml.internal.geometry;

import java.io.*;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class PositionInterpolator extends Interpolator
{
	private MFVec3f	_set_keyValue;

	private ConstSFVec3f	_get_value_changed;

	private float[][]	_keyValue;

	public PositionInterpolator(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("PositionInterpolator {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		createFields();
	}

	private void createFields()
	{
		_set_keyValue = (MFVec3f)node.getEventIn("keyValue");

		_get_value_changed = (ConstSFVec3f)node.getEventOut("value_changed");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.PositionInterpolator;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int	i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println(buffer.toString() + "PositionInterpolator {");

		if(_key != null)
		{
			fp.println(buffer.toString() + "  key [");
			
			for(i = 0; i < _key.length; i++)
				fp.println(buffer.toString() + "    " + _key[i]);

			fp.println(buffer.toString() + "  ]");
		}
		
		if(_keyValue != null)
		{
			fp.println(buffer.toString() + "  keyValue [");
			
			// now print the keyValues, 1 per line
			for(i = 0; i < _keyValue.length; i++)
				fp.println(buffer.toString() + "    " +
				           _keyValue[i][0] + " " +
				           _keyValue[i][1] + " " +
				           _keyValue[i][2]);

			fp.println(buffer.toString() + "  ]");
		}
		
		fp.println(buffer.toString() + "}");
	}
	
	public void set_keyValue(float[][] positions)
	{
		_keyValue = positions;
		if(have_browser)
			_set_keyValue.setValue(_keyValue);
	}
	
	public float[][] get_keyValue()
	{
		return(_keyValue);
	}

	public float[] get_value_changed()
	{
		float[] val = null;

		_get_value_changed.getValue(val);
		return(val);
	}
}