// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// TextureCoordinate class.

package vlc.vrml.internal.geometry;

import java.io.PrintStream;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class TextureCoordinate extends VrmlObject
{
	private MFVec2f _set_point;

	private float[][] _point;

	public TextureCoordinate(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("TextureCoordinate {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		createFields();
	}

	private void createFields()
	{
		_set_point = (MFVec2f)node.getEventIn("point");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.TextureCoordinate;
	}
	public void finalize()
	{
		_point = null;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int     i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "texCoord ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println("TextureCoordinate {");

		if(_point.length > 0)
		{
			fp.print(buffer.toString() + "  point ");

			if(_point.length == 1)
				fp.println(_point[0]);
			else
			{
				fp.println("[");

				for(i = 0; i < _point.length; i++)
					fp.println(buffer.toString() + "  " + _point[i]);

				fp.println(buffer.toString() + "  ]");
			}
		}
		fp.println(buffer.toString() + "}");
	}

	public void set_point(float[][] point)
	{
		_point = point;
		if(have_browser)
			_set_point.setValue(point);
	}
	
	public float[][] get_point()
	{
		return(_point);
	}
}
