// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// TouchSensor class

package vlc.vrml.internal.geometry;

import java.io.*;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class TouchSensor extends Sensor
{
	private ConstSFVec3f	_get_hitNormal_changed;
	private ConstSFVec3f	_get_hitPoint_changed;
	private ConstSFVec2f	_get_hitTexCoord_changed;
	private ConstSFBool		_get_isOver;
	private ConstSFTime		_get_touchTime;

	public TouchSensor(Browser b)
	{
		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString("TouchSensor {}")[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}

		createFields();
	}

	private void createFields()
	{
		_set_enabled = (SFBool)node.getEventIn("enabled");

		_get_isActive = (ConstSFBool)node.getEventOut("isActive");
		_get_hitNormal_changed = (ConstSFVec3f)node.getEventOut("hitNormal_changed");
		_get_hitPoint_changed = (ConstSFVec3f)node.getEventOut("hitPoint_changed");
		_get_hitTexCoord_changed = (ConstSFVec2f)node.getEventOut("hitTexCoord_changed");
		_get_isOver = (ConstSFBool)node.getEventOut("isOver");
		_get_touchTime = (ConstSFTime)node.getEventOut("touchTime");

		have_browser = true;
		type = vlc.vrml.VrmlTypes.TouchSensor;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int	i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println(buffer.toString() + "TouchSensor {");

		if(!_enabled)
			fp.println(buffer.toString() + "  enabled FALSE");

		fp.println(buffer.toString() + "}");
	}

	public float[] get_hitNormal_changed()
	{
		float[] val = null;

		_get_hitNormal_changed.getValue(val);

		return(val);
	}

	public float[] get_hitPoint_changed()
	{
		float[] val = null;

		_get_hitPoint_changed.getValue(val);

		return(val);
	}

	public float[] get_hitTexCoord_changed()
	{
		float[] val = null;

		_get_hitTexCoord_changed.getValue(val);

		return(val);
	}

	public boolean get_isOver()
	{
		return(_get_isOver.getValue());
	}

	public double get_touchTime()
	{
		return(_get_touchTime.getValue());
	}
}