// VRML Generator
// Copyright Justin Couch 1996
//
// From Chapter 13 Late Night VRML 2.0 and Java
//
// VRML base object definition for the internal classes

package vlc.vrml.internal.geometry;

import java.lang.Cloneable;
import java.io.PrintStream;
import vrml.node.Node;

public abstract class VrmlObject implements Cloneable
{
	protected boolean have_browser = false;
	protected int		type = -1;

	public String name = null;
	public Node   node = null;

	// called just before a node is to be deleted by its parent. A blank
	// version is provided for nodes that don't need to do anything
	public void cleanup()
	{
	}

	public abstract void writeToFile(PrintStream fp, int indent);

	public String toString()
	{
		return(name);
	}

	public int get_nodeType()
	{
		return(type);
	}
}

