// VRML Generator
// Copyright Justin Couch 1996
//
// Chapter 13: Late Night VRML 2.0 and Java
//
// WorldInfo class.

package vlc.vrml.internal.geometry;

import java.io.PrintStream;
import vrml.*;
import vrml.field.*;
import vrml.node.Node;

public class WorldInfo extends ChildrenNode
{
	String[]	_info;
	String		_title;

	// this is the one case where the default constuctors are useless.
	// so don't put them in!

	public WorldInfo(Browser b, String[] info, String title)
	{
		_info = info;
		_title = title;

		if(b == null)
			return;

		try
		{
			node = (Node)b.createVrmlFromString(createString())[0];
		}
		catch(InvalidVRMLSyntaxException e)
		{
		}
		
		createFields();
	}

	private void createFields()
	{
		have_browser = true;
		type = vlc.vrml.VrmlTypes.WorldInfo;
	}

	private String createString()
	{
		int	i;
		String vrml_string = "WorldInfo { ";

		if(_title != null)
			vrml_string += "title " + _title;

		if(_info != null)
		{
			vrml_string += "info [";

			for(i = 0; i < _info.length; i++)
				vrml_string += " \"" + _info[i] + "\"";

			vrml_string += " ]";
		}

		vrml_string += "}";

		return(vrml_string);
	}

	public void cleanup()
	{
		_title = null;
		_info = null;
	}

	public void writeToFile(PrintStream fp, int indent)
	{
		int     i;
		StringBuffer buffer = new StringBuffer();

		for(i = 0; i < indent; i++)
			buffer.append("  ");

		fp.print(buffer.toString() + "texture ");
		if(name != null)
			fp.print("DEF " + name + " ");

		fp.println("WorldInfo {");

		if(_title != null)
			fp.println(buffer.toString() + "  title " + _title);
			
		if(_info.length > 0)
		{
			fp.println(buffer.toString() + " info [");

			for(i = 0; i < _info.length; i++)
			{
				fp.println(buffer.toString() + "    \"" +
					   _info[i] + "\"");
			}
			fp.println(buffer.toString() + "  ]");
		}
		fp.println(buffer.toString() + "}");
	}

	public String[] get_info()
	{
		return(_info);
	}

	public String get_title()
	{
		return(_title);
	}
}
