// Native methods for reading devices using
// DirectInput under Windows 95

// Written by Bernie Roehl, February 1997

#pragma aux Input6D_nativePoll "*"
#pragma aux Input6D_nativeSetup "*"

#include "Input6D.h"
#include <windows.h>
#include <string.h>

void Input6D_nativePoll(struct HInput6D *this)
{
    ClassInput6D *data = unhand(this);
    JOYINFOEX info;
    info.dwSize = sizeof(info);
    info.dwFlags = JOY_RETURNALL;
    data->status = joyGetPosEx(data->port, &info);
    data->rawX = info.dwXpos;
    data->rawY = info.dwYpos;
    data->rawZ = info.dwZpos;
    data->rawR = info.dwRpos;
    data->rawU = info.dwUpos;
    data->rawV = info.dwVpos;
    data->changed = 1;   // true
    if (data->buttons != info.dwButtons) {
        data->buttons = info.dwButtons;
        data->whichButton = info.dwButtonNumber;
        data->buttonChanged = 1;         // true
    }
}

void Input6D_nativeSetup(struct HInput6D *obj)
{
    ClassInput6D *data = unhand(obj);
    JOYCAPS caps;
    data->status = joyGetDevCaps(data->port, &caps, sizeof(caps));
    if (data->status != 0)
        return;
    data->minX = caps.wXmin;  data->maxX = caps.wXmax;
    data->minY = caps.wYmin;  data->maxY = caps.wYmax;
    data->minZ = caps.wXmin;  data->maxZ = caps.wZmax;
    data->minR = caps.wRmin;  data->maxR = caps.wRmax;
    data->minU = caps.wUmin;  data->maxU = caps.wUmax;
    data->minV = caps.wVmin;  data->maxV = caps.wVmax;
    data->nbuttons = caps.wNumButtons;
    data->description = makeJavaString(caps.szPname, strlen(caps.szPname));
}

