import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class Region extends Script {
    private SFInt32 showChildren;
    private int count = 0;
    private String regionName;

    public void initialize() {
        showChildren = (SFInt32) getEventOut("showChildren");
        SFString name = (SFString) getField("name");
        regionName = name.getValue();
    }

    public void processEvent(Event e) {
System.out.println("Got event " + e.getName());
        if (e.getName().equals("regionActive")) {
            ConstSFBool in = (ConstSFBool) e.getValue();
            if (in.getValue())
                System.out.println("entered " + regionName);
            else
                System.out.println("left " + regionName);
        }
        if (e.getName().equals("countThese")) {
            ConstSFBool in = (ConstSFBool) e.getValue();    
            count += (in.getValue()) ? 1 : -1;
System.out.println("for region " + regionName + ", count is " + count);
            showChildren.setValue((count > 0) ? 0 : -1);
        }
    }

}

