// The Chess applet

// Written by Bernie Roehl, March 1997

import java.applet.*;
import java.util.*;
import java.awt.*;
import java.io.*;
import netscape.javascript.JSObject;
import vrml.external.Browser;
import vrml.external.Node;
import vrml.external.field.*;
import vrml.external.exception.*;

public class chess
    extends Applet
    implements Runnable, EventOutObserver {

    static boolean move_made = false;

    Thread myThread;
    Browser browser;          // the VRML browser

    public String getAppletInfo() {
        return "VRML Chess Interface " + 0.1 + ", written by Bernie Roehl";
    }

    Piece pieces[] = {
        new Piece("BlackRook1"), new Piece("BlackKnight1"),
        new Piece("BlackBishop1"),
        new Piece("BlackKing"), new Piece("BlackQueen"),
        new Piece("BlackBishop2"), new Piece("BlackKnight2"),
        new Piece("BlackRook2"),
        new Piece("BlackPawn1"), new Piece("BlackPawn2"),
        new Piece("BlackPawn3"), new Piece("BlackPawn4"), 
        new Piece("BlackPawn5"), new Piece("BlackPawn6"),
        new Piece("BlackPawn7"), new Piece("BlackPawn8"), 
        new Piece("WhiteRook1"), new Piece("WhiteKnight1"),
        new Piece("WhiteBishop1"),
        new Piece("WhiteKing"), new Piece("WhiteQueen"),
        new Piece("WhiteBishop2"), new Piece("WhiteKnight2"),
        new Piece("WhiteRook2"),
        new Piece("WhitePawn1"), new Piece("WhitePawn2"), new Piece("WhitePawn3"),
        new Piece("WhitePawn4"), 
        new Piece("WhitePawn5"), new Piece("WhitePawn6"), new Piece("WhitePawn7"),
        new Piece("WhitePawn8")
    };

    public void start() {
        browser = getBrowser();
        for (int i = 0; i < pieces.length; ++i)
            pieces[i].restart(browser, this);
        if (myThread == null)
            myThread = new Thread(this);
        myThread.start();
    }

    public void stop() {
       if (myThread != null)
           myThread.stop();
    }

    public void run() {
System.out.println("run");
        while (true) {
            if (move_made) {
                System.out.println("Move made!");
                move_made = false;
            }
        }
    }

    private Browser getBrowser() {
        Browser browser = Browser.getBrowser();
        if (browser == null) {
            JSObject win = JSObject.getWindow(this);
            if (win != null) {
                JSObject doc = (JSObject) win.getMember("document");
                JSObject embeds = (JSObject) doc.getMember("embeds");
                JSObject applets = (JSObject) doc.getMember("applets");
                JSObject frames = (JSObject) doc.getMember("frames");
                for (int i = 0; i < 10; ++i) {
                    browser = (Browser) embeds.getSlot(0);
                    if (browser != null)
                        break;
                    try { Thread.sleep(500); }
                    catch (InterruptedException e) { }
                }
            }
        }
        return browser;
    }

    private int n = 0;  // used to count callbacks

    public void callback(EventOut event, double time, Object userData) {
        EventOutSFBool active = (EventOutSFBool) event;
        if (active.getValue())
            return;
        Piece piece = (Piece) userData;
        piece.updateLocation();
        float[] loc = piece.getLocation();
        int rank = 4 + -(int) Math.floor(loc[1] / 0.12);
        int file = 5 + (int) Math.floor(loc[0] / 0.12);
System.out.print(piece.getName() + " moved to ");
System.out.println("[" + rank + ", " + file + "]");
        String otherpiece = "Black" + piece.getName().substring(5);
System.out.println("reponse: move " + otherpiece + " to " + (9-rank) + ", " + file);
        Node other = browser.getNode(otherpiece);
        EventInSFVec3f set_location = (EventInSFVec3f) other.getEventIn("set_location");
        loc[1] = -loc[1];
        set_location.setValue(loc);
        move_made = true;
    }
}

class Piece {
    String name;
    Node node;
    float[] initialLocation = new float[3];
    float[] currentLocation = new float[3];
    String getName() { return name; }
    float[] getLocation() {
        float[] loc = new float[2];
        loc[0] = initialLocation[0] + currentLocation[0];
        loc[1] = initialLocation[2] + currentLocation[1];
        return loc;
    }
    public Piece(String nam) {
        name = nam;
    }
    public void restart(Browser browser, EventOutObserver observer) {
        node = null;
        while (node == null) {
            try { node = browser.getNode(name); }
            catch (InvalidNodeException e) { }
        }
        EventOutSFVec3f loc = (EventOutSFVec3f) node.getEventOut("initialLocation");
        initialLocation = loc.getValue();
        updateLocation();
        EventOutSFBool isActive = (EventOutSFBool) node.getEventOut("isActive");
        isActive.advise(observer, this);
    }
    public void updateLocation() {
        EventOutSFVec3f loc = (EventOutSFVec3f) node.getEventOut("location_changed");
        currentLocation = loc.getValue();
    }
}


